//+------------------------------------------------------------------+
//|                                                IndexKorVisio.mq4 |
//|                                          Copyright  2009, Urain |
//|                                        voidpiligrim |
//+------------------------------------------------------------------+

/******************************************************************************************************************
  :
   1   Index-  .
   2   Index-    ( ?)=>
   =>    Index-  .( Index- . Kor[])
   3   . Index- . Kor[]
   4   2 Index- (  chart-    ind.)   ( ?)=>
   =>    Index-  .(2 Index-)~~~~~~~~~~~~~~~~~~~~    
 
 Global "SDVIG"   ,
 ( .   InitAllIndicators.mq4     "SDVIG")
  ans -  .    Index-    . Index()
 .. ind.   Open   int flag     (      ).
*******************************************************************************************************************/
#property copyright "Copyright  2009,  Urain"
//----
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Yellow
#property indicator_color2 RoyalBlue
#property indicator_color3 Aqua
#property indicator_color4 Brown
#property indicator_color5 Red
#property indicator_color6 Green
#property indicator_color7 Coral /* */
//---- input parameters  chart   separate
extern int ALERT =0;
extern int Znac  =1;// -1  Kor[]   Visio = 3
extern int Visio =3;
extern int Count =2000;// . Bar  
//---- buffers
double I_USD[];
double I_GBP[];
double I_EUR[];
double I_CHF[];
double I_JPY[];
double I_CAD[];
double I_AUD[];
double Kor[];
double Vp[];
double Np[];

int V,N,Fip;
int fip=0;
double GBPUSD, EURUSD, USDCHF, USDJPY, USDCAD, AUDUSD;
   double ans; 
   double USD, GBP, EUR, CHF, JPY, CAD, AUD;
   double iUSD0,iGBP1, iEUR2, iCHF3, iJPY4, iCAD5, iAUD6;
   double USD0, GBP1, EUR2, CHF3, JPY4, CAD5, AUD6;
   double KOR;    
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  { 
   Symbol_Int( V, N);
  if(Visio <= 1)
    {
     int i=0;while(i<7){SetIndexStyle(i,DRAW_LINE);i++;}
     SetIndexBuffer(0,I_USD);SetIndexBuffer(1,I_GBP);SetIndexBuffer(2,I_EUR);SetIndexBuffer(3,I_CHF);
     SetIndexBuffer(4,I_JPY);SetIndexBuffer(5,I_CAD);SetIndexBuffer(6,I_AUD);
    }
   if(Visio==2){SetIndexStyle(0,DRAW_LINE);SetIndexBuffer(0,Vp);SetIndexStyle(1,DRAW_LINE);SetIndexBuffer(1,Np);} 
   if(Visio==3){SetIndexStyle(0,DRAW_LINE);SetIndexBuffer(0,Kor);}
   
   if(!GlobalVariableCheck( "SDVIG"))GlobalVariableSet("SDVIG",0);
//---- name for DataWindow and indicator subwindow label   
   IndicatorShortName("IndexKor");
   SetIndexDrawBegin(0,2);
   return(0);
  }

  
int deinit(){GlobalVariableDel( "SDVIG");return(0);}  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {int start_=GetTickCount();
   

   
//---- 
   int flag=1; 
   int i=0;int sh=GlobalVariableGet("SDVIG"); 
   while(i<=Count)// . Bar 
     {
      if(flag==1){i=sh;}
      GBPUSD=iOpen("GBPUSD",NULL,i);//Open Close
      EURUSD=iOpen("EURUSD",NULL,i);
      USDCHF=iOpen("USDCHF",NULL,i);
      USDJPY=iOpen("USDJPY",NULL,i)*0.01;
      USDCAD=iOpen("USDCAD",NULL,i);
      AUDUSD=iOpen("AUDUSD",NULL,i);
      ans =MathPow( (USDCHF*USDJPY*USDCAD*MathPow( GBPUSD, 6)*MathPow( EURUSD, 6)*MathPow( AUDUSD, 6)), 1/7);
      //*****************************************************************************************************
      iUSD0=Index( 0,ans);           
      iGBP1=Index( 1,ans);                                            
      iEUR2=Index( 2,ans);                                            
      iCHF3=Index( 3,ans);                                            
      iJPY4=Index( 4,ans);
      iCAD5=Index( 5,ans);
      iAUD6=Index( 6,ans);     
      //***********************************************************
      if(Visio ==-1)
       {
        I_USD[i]=iUSD0;
        I_GBP[i]=iGBP1;
        I_EUR[i]=iEUR2;
        I_CHF[i]=iCHF3;
        I_JPY[i]=iJPY4;
        I_CAD[i]=iCAD5;
        I_AUD[i]=iAUD6;
       }      
      //*********************************************************** 
      if(Visio ==0)
       {
        if(i==sh)
         {
          USD0=iUSD0;I_USD[i]=0.0;
          GBP1=iGBP1;I_GBP[i]=0.0;
          EUR2=iEUR2;I_EUR[i]=0.0;
          CHF3=iCHF3;I_CHF[i]=0.0;
          JPY4=iJPY4;I_JPY[i]=0.0;
          CAD5=iCAD5;I_CAD[i]=0.0;
          AUD6=iAUD6;I_AUD[i]=0.0;
         }
        else
         {
          I_USD[i]=iUSD0-USD0;
          I_GBP[i]=iGBP1-GBP1;
          I_EUR[i]=iEUR2-EUR2;
          I_CHF[i]=iCHF3-CHF3;
          I_JPY[i]=iJPY4-JPY4;
          I_CAD[i]=iCAD5-CAD5;
          I_AUD[i]=iAUD6-AUD6;
         }  
       }            
      //*********************************************************** 
      if(Visio ==1)
       {
        KOR=(iUSD0+iGBP1+iEUR2+iCHF3+iJPY4+iCAD5+iAUD6)*(1.0/7.0);
        iUSD0-=KOR; iGBP1-=KOR; iEUR2-=KOR; iCHF3-=KOR; iJPY4-=KOR; iCAD5-=KOR; iAUD6-=KOR; 
        if(i==sh)
         {
          USD0=iUSD0;I_USD[i]=0.0;
          GBP1=iGBP1;I_GBP[i]=0.0;
          EUR2=iEUR2;I_EUR[i]=0.0;
          CHF3=iCHF3;I_CHF[i]=0.0;
          JPY4=iJPY4;I_JPY[i]=0.0;
          CAD5=iCAD5;I_CAD[i]=0.0;
          AUD6=iAUD6;I_AUD[i]=0.0;
         }
        else
         {
          I_USD[i]=iUSD0-USD0;
          I_GBP[i]=iGBP1-GBP1;
          I_EUR[i]=iEUR2-EUR2;
          I_CHF[i]=iCHF3-CHF3;
          I_JPY[i]=iJPY4-JPY4;
          I_CAD[i]=iCAD5-CAD5;
          I_AUD[i]=iAUD6-AUD6;
         }  
       }            
      //*********************************************************** 
      if(Visio ==2)
       {Fip=0;
        KOR=(iUSD0+iGBP1+iEUR2+iCHF3+iJPY4+iCAD5+iAUD6)*(1.0/7.0);
        Index_Para( Vp, Np,i,sh); 
       }            
      //*********************************************************** 
      if(Visio ==3)
       {
        Kor[i]=Znac*(iUSD0+iGBP1+iEUR2+iCHF3+iJPY4+iCAD5+iAUD6)*(1.0/7.0);
       }            
      //***********************************************************                       
      if(flag==1){i=(-1);flag=0;}    
      i++;
     }
     if(Fip ==0&&Visio ==2&&fip ==0){fip=1;Alert("Error   ");}
//----
if(ALERT==1)Alert("  ", (GetTickCount()-start_)*0.001, " .");
//----
   return(0);
  }
//**********************************************************************************************************************
//+------------------------------------------------------------------+
void Index_Para(double& Vp[],double& Np[],int i,int sh)
   {//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    if(N==3){if(V==0&&Fip==0){Fip=1;iUSD0-=KOR;iCHF3-=KOR;if(i==sh){USD0=iUSD0;Vp[i]=0.0;CHF3=iCHF3;Np[i]=0.0;}else{Vp[i]=iUSD0-USD0;Np[i]=iCHF3-CHF3;}
       }else{if(V==1&&Fip==0){Fip=1;iGBP1-=KOR;iCHF3-=KOR;if(i==sh){GBP1=iGBP1;Vp[i]=0.0;CHF3=iCHF3;Np[i]=0.0;}else{Vp[i]=iGBP1-GBP1;Np[i]=iCHF3-CHF3;}
       }else{if(V==2&&Fip==0){Fip=1;iEUR2-=KOR;iCHF3-=KOR;if(i==sh){EUR2=iEUR2;Vp[i]=0.0;CHF3=iCHF3;Np[i]=0.0;}else{Vp[i]=iEUR2-EUR2;Np[i]=iCHF3-CHF3;}
       }}}}else{
    if(N==4){if(V==0&&Fip==0){Fip=1;iUSD0-=KOR;iJPY4-=KOR;if(i==sh){USD0=iUSD0;Vp[i]=0.0;JPY4=iJPY4;Np[i]=0.0;}else{Vp[i]=iUSD0-USD0;Np[i]=iJPY4-JPY4;}
       }else{if(V==1&&Fip==0){Fip=1;iGBP1-=KOR;iJPY4-=KOR;if(i==sh){GBP1=iGBP1;Vp[i]=0.0;JPY4=iJPY4;Np[i]=0.0;}else{Vp[i]=iGBP1-GBP1;Np[i]=iJPY4-JPY4;}
       }else{if(V==2&&Fip==0){Fip=1;iEUR2-=KOR;iJPY4-=KOR;if(i==sh){EUR2=iEUR2;Vp[i]=0.0;JPY4=iJPY4;Np[i]=0.0;}else{Vp[i]=iEUR2-EUR2;Np[i]=iJPY4-JPY4;}
       }}}}else{
    if(N==0){if(V==1&&Fip==0){Fip=1;iGBP1-=KOR;iUSD0-=KOR;if(i==sh){GBP1=iGBP1;Vp[i]=0.0;USD0=iUSD0;Np[i]=0.0;}else{Vp[i]=iGBP1-GBP1;Np[i]=iUSD0-USD0;}
       }else{if(V==2&&Fip==0){Fip=1;iEUR2-=KOR;iUSD0-=KOR;if(i==sh){EUR2=iEUR2;Vp[i]=0.0;USD0=iUSD0;Np[i]=0.0;}else{Vp[i]=iEUR2-EUR2;Np[i]=iUSD0-USD0;}
       }else{if(V==6&&Fip==0){Fip=1;iAUD6-=KOR;iUSD0-=KOR;if(i==sh){AUD6=iAUD6;Vp[i]=0.0;USD0=iUSD0;Np[i]=0.0;}else{Vp[i]=iAUD6-AUD6;Np[i]=iUSD0-USD0;}
       }}}}else{
    if(N==1){if(V==2&&Fip==0){Fip=1;iEUR2-=KOR;iGBP1-=KOR;if(i==sh){EUR2=iEUR2;Vp[i]=0.0;GBP1=iGBP1;Np[i]=0.0;}else{Vp[i]=iEUR2-EUR2;Np[i]=iGBP1-GBP1;}
}}else{if(N==5&&V==0&&Fip==0){Fip=1;iUSD0-=KOR;iCAD5-=KOR;if(i==sh){USD0=iUSD0;Vp[i]=0.0;CAD5=iCAD5;Np[i]=0.0;}else{Vp[i]=iUSD0-USD0;Np[i]=iCAD5-CAD5;}}
    }}}}
    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    return;
   }  
//+------------------------------------------------------------------+
void Symbol_Int(int& V,int& N)
   {
    if(Symbol()=="GBPUSD"){V=1;N=0;}else{ 
    if(Symbol()=="EURUSD"){V=2;N=0;}else{ 
    if(Symbol()=="USDCHF"){V=0;N=3;}else{ 
    if(Symbol()=="USDJPY"){V=0;N=4;}else{ 
    if(Symbol()=="USDCAD"){V=0;N=5;}else{ 
    if(Symbol()=="AUDUSD"){V=6;N=0;}else{ 
    if(Symbol()=="EURCHF"){V=2;N=3;}else{ 
    if(Symbol()=="EURGBP"){V=2;N=1;}else{ 
    if(Symbol()=="EURJPY"){V=2;N=4;}else{ 
    if(Symbol()=="GBPCHF"){V=1;N=3;}else{ 
    if(Symbol()=="GBPJPY"){V=1;N=4;}}}}}}}}}}} 
    return;
   }
//+------------------------------------------------------------------+    
double Index(int Ind,double ans)
      {double X =0;
        
       switch(Ind)
            {
             case 0:
                   X=1/GBPUSD/EURUSD/AUDUSD*ans;
                   //USD
                   break;
             case 1:
                   X=1/EURUSD/AUDUSD*ans;
                   //GBP
                   break;
             case 2:
                   X=1/GBPUSD/AUDUSD*ans;
                   //EUR
                   break;
             case 3:
                   X=1/GBPUSD/EURUSD/AUDUSD*ans/USDCHF;
                   //CHF
                   break;
             case 4:
                   X=1/GBPUSD/EURUSD/AUDUSD*ans/USDJPY;
                   //JPY
                   break;
                   //
             case 5:
                   X=1/USDCAD/GBPUSD/EURUSD/AUDUSD*ans;
                   //CAD
                   break;
             case 6:
                   X=1/GBPUSD/EURUSD*ans; 
                   //AUD
                   break;
             default:  Alert("func Index =default ERROR");break;      
            }
              
       return(X);
       }
//+--------------------------------------------------------------------+
 
 
       